#!/usr/bin/perl
# Сравнивает адреса УИК в двух CSV (уик,адрес), выдаёт разницу
use utf8;
binmode STDOUT, ":encoding(utf8)";
open FILE1, "<$ARGV[0]";
while(<FILE1>) {
    chomp;
    @line = split /\t/;
    utf8::decode($line[1]);
    $csv{$line[0]} = [$line[1], '-'];
}
close FILE1;

open FILE2, "<$ARGV[1]";
while(<FILE2>) {
    chomp;
    @line = split /\t/;
    utf8::decode($line[1]);
    if( defined($csv{$line[0]}) ) {
	$csv{$line[0]}[1] = $line[1];
    } else {
	$csv{$line[0]} = ['-', $line[1]];
    }
}
close FILE2;

$cnt = 0;
foreach $k (keys %csv) {
    $eq = prep($csv{$k}[0]) eq prep($csv{$k}[1]);
    print "$k\t$csv{$k}[0]\t$csv{$k}[1]\n" if !$eq;
    $cnt++ if $eq;
}
print "$cnt addresses are same\n";

sub prep {
    $a = lc shift;
    $a =~ s/\bд\./дом/;
    $a =~ s/\bул\./улица/;
    $a =~ s/\bкорп\./корпус/;
    $a =~ s/\bк\./корпус/;
    $a =~ s/\bпр\./проспект/;
    $a =~ s/\bнаб\./набережная/;
    $a =~ s/\bпер\./переулок/;
    $a =~ s/[\s.,]//g;
    #print $a;
    return $a;
}
