#!/usr/bin/perl
# Превращает CSV (уик,адрес,описание,телефон) в OSM, координаты берёт из второго CSV (уик,адрес,описание,телефон,lat,lon)
# Что не найдено, кладёт в центр. Где отличается адрес, добавляет тег tourism=attraction
use utf8;
binmode STDOUT, ":encoding(utf8)";
open FILE1, "<$ARGV[0]";
while(<FILE1>) {
    chomp;
    utf8::decode($_);
    @line = split /\t/;
    $csv0{$line[0]} = [$line[1], $line[4], $line[5]];
}
close FILE1;

@csv = ();
$lat0 = 0.0; $lon0 = 0.0; $cnt = 0; $fix = 0;
open FILE2, "<$ARGV[1]";
while(<FILE2>) {
    utf8::decode($_);
    s/[\n\r ]+$//;
    s/&/&amp;/g;
    s/\</&lt;/g;
    s/\>/&gt;/g;
    s/"/&quot;/g;
    s/'/&apos;/g;
    @line = split /\t/;
    print STDERR "Warning at ref $line[0]\n" if $#line < 3;
    $eq = 0;
    if( defined($csv0{$line[0]}) ) {
	push @line, ($csv0{$line[0]}[1], $csv0{$line[0]}[2]);
	$eq = prep($csv0{$line[0]}[0]) eq prep($line[1]);
    } else {
	push @line, (0.0, 0.0);
    }
    push @line, $eq;
    $lat0 += $line[4];
    $lon0 += $line[5];
    $cnt++ if $line[4] > 1;
    $fix++ if !$eq;
    push @csv, [ @line ];
}
close FILE2;
$lat0 /= $cnt;
$lon0 /= $cnt;

print "<?xml version='1.0' encoding='UTF-8'?>\n<osm version='0.6' generator='csv2osm.pl'>\n";
print "<!-- Need fixing $fix nodes -->\n";
$id = -1;
@keys = ('ref', 'address', 'name', 'phone');

for $i (0 .. $#csv) {
    ($lat, $lon) = ($csv[$i][4], $csv[$i][5]);
    $lat = $lat0 if $lat < 1;
    $lon = $lon0 if $lon < 1;
    for $j (0 .. $i-1) {
	if( $lat == $csv[$j][4] && $lon == $csv[$j][5] ) {
	    $lat -= 0.0001;
	}
    }
    $csv[$i][4] = $lat;
    $csv[$i][5] = $lon;
    print "<node id='$id' lat='$lat' lon='$lon'>\n";
    print "\t<tag k='$keys[$_]' v='$csv[$i][$_]' />\n" for 0..$#keys;
    print "\t<tag k='tourism' v='attraction' />\n" if !$csv[$i][6];
    print "</node>\n";
    $id--;
}
print "</osm>";

sub prep {
    $a = lc shift;
    $a =~ s/\bд\./дом/;
    $a =~ s/\bул\./улица/;
    $a =~ s/\bкорп\./корпус/;
    $a =~ s/\bк\./корпус/;
    $a =~ s/\bпр\./проспект/;
    $a =~ s/\bнаб\./набережная/;
    $a =~ s/\bпер\./переулок/;
    $a =~ s/[\s.,]//g;
    #print $a;
    return $a;
}
