#!/usr/bin/perl
# Делает из списка результатов голосования и списка УИК с адресами KML, дифференцированный по результатам Единой России
use utf8;
binmode STDOUT, ":utf8";

open F, "<$ARGV[0]";
while(<F>) {
    chomp;
    @list = split /,\s*/;
    $list[5] =~ /(\d+)/;
    $results{$1} = [ @list ];
}
close F;

$er_green = '';
$er_yellow = '';
$er_red = '';

open F, "<$ARGV[1]";
while(<F>) {
    utf8::decode($_);
    s/[\n\r ]+$//;
    s/&/&amp;/g;
    s/\</&lt;/g;
    s/\>/&gt;/g;
    s/"/&quot;/g;
    s/'/&apos;/g;
    @line = split /\t/;
    print STDERR "Warning at ref $line[0]\n" if $#line < 7;
    if( !exists $results{$line[0]} ) {
	print STDERR "No results for $line[0]\n";
	next;
    }
    @res = @{$results{$line[0]}};

    $votes = $res[13];
    $visit = $votes + $res[23];
    $total = $res[14];

    $r = "\t<Placemark>\n";
    $r .= "\t\t<styleUrl>STYLE</styleUrl>\n";
    $r .= "\t\t<name>$line[0]</name>\n";
    $r .= "\t\t<description><![CDATA[";
    $r .= "$line[1] ($line[2]), тел. $line[3]<br>$line[7], ТИК №$line[6]<br>";
    $r .= "Явка: $visit (".perc($visit,$total).")<br>";
    $r .= "<br><b>Распределение голосов:</b><br>";
    $r .= "Справедливая Россия: ".perc($res[6],$votes)."<br>";
    $r .= "ЛДПР: ".perc($res[7],$votes)."<br>";
    $r .= "Патриоты России: ".perc($res[8],$votes)."<br>";
    $r .= "КПРФ: ".perc($res[9],$votes)."<br>";
    $r .= "Яблоко: ".perc($res[10],$votes)."<br>";
    $r .= "Единая Россия: ".perc($res[11],$votes)."<br>";
    $r .= "Правое дело: ".perc($res[12],$votes)."<br>";
    $r .= "]]></description>\n";
    $r .= "\t\t<Point><coordinates>$line[5],$line[4]</coordinates></Point>\n";
    $r .= "\t</Placemark>\n";

    $er = 100*$res[11]/$votes;
    if( $er < 35 ) { $er_green .= $r; }
    elsif( $er > 50 ) { $er_red .= $r; }
    else { $er_yellow .= $r; }
}
close F;

$er_green =~ s/STYLE/#green/g;
$er_yellow =~ s/STYLE/#yellow/g;
$er_red =~ s/STYLE/#red/g;
print "<?xml version='1.0' encoding='UTF-8'?>\n<kml xmlns=\"http://www.opengis.net/kml/2.2\">\n";
print "<Document>\n<name>Результаты выборов 4.12.2011</name>\n<description>Результаты выборов в Думу 4 декабря 2011, дифференцированные по доле голосов за Единую Россию. Исходные данные собраны на &lt;a href=\"http://wiki.gis-lab.info/w/Проект_УИК_Петербурга\"&gt;странице проекта&lt;/a&gt;</description>\n";
print "<Style id=\"green\">\n\t<IconStyle><color>ff00ff00</color><scale>1</scale><hotSpot x=\"15\" y=\"16\" xunits=\"pixels\" yunits=\"pixels\"/><Icon><href>green.png</href></Icon></IconStyle>\n</Style>\n";
print "<Style id=\"yellow\">\n\t<IconStyle><color>ff00ffff</color><scale>1</scale><hotSpot x=\"15\" y=\"16\" xunits=\"pixels\" yunits=\"pixels\"/><Icon><href>yellow.png</href></Icon></IconStyle>\n</Style>\n";
print "<Style id=\"red\">\n\t<IconStyle><color>ff0000ff</color><scale>1</scale><hotSpot x=\"15\" y=\"16\" xunits=\"pixels\" yunits=\"pixels\"/><Icon><href>red.png</href></Icon></IconStyle>\n</Style>\n";
print "<Folder>\n\t<name>УИК с процентом ЕР меньше 35</name>\n$er_green</Folder>\n";
print "<Folder>\n\t<name>УИК с процентом ЕР от 35 до 50</name>\n$er_yellow</Folder>\n";
print "<Folder>\n\t<name>УИК с процентом ЕР более 50</name>\n$er_red</Folder>\n";
print "</Document>\n</kml>";

sub perc {
    my ($val, $total) = @_;
    return sprintf("%.1f%%", 100*$val/$total);
}
